const courseTargetList = [
  {
    name: "课程目标1",
    indicator:
      "系统掌握高等数学中的基本概念、基本方法、基本技巧(A1)\n熟练掌握求极限的基本方法与技巧、判断函数的连续性(A2)\n熟练掌握求导数的基本方法与技巧(A3)\n熟练掌握求不定积分与定积分的基本方法与技巧(A4)\n掌握一阶及二阶微分方程的解法(A5)\n熟练掌握多元函数极限的求法、偏导数及全微分的求法，复合函数求导的基本方法与技巧(A6)\n熟练掌握多元函数积分学的基本方法与解题技巧(A7)\n掌握级数敛散性判别法，简单的幂级数求和函数及函数展开成幂级数(A8)",
    demand: "",
    commentGist: "",
    getVal: 0.67,
    steps: [
      {
        name: "平时作业",
        rate: "10%",
        score: 40,
        aveScore: 25.93,
      },
      {
        name: "期中考查",
        rate: "20%",
        score: 5,
        aveScore: 4.23,
      },
      {
        name: "期末考试",
        rate: "70%",
        score: 10,
        aveScore: 7.82,
      },
    ],
  },
  {
    name: "课程目标2",
    indicator:
      "掌握数列极限、函数极限的基本概念、性质并会求极限(B1)\n微分中值定理的证明及其应用(B2)\n隐函数求导(B3)\n幂级数求和函数及函数展开成幂级数(B4)",
    demand: "",
    commentGist: "",
    getVal: 0.75,
    steps: [
      {
        name: "平时作业",
        rate: "10%",
        score: 40,
        aveScore: 27.93,
      },
      {
        name: "期中考查",
        rate: "20%",
        score: 5,
        aveScore: 4.23,
      },
      {
        name: "期末考试",
        rate: "70%",
        score: 10,
        aveScore: 7.82,
      },
    ],
  },
  {
    name: "课程目标3",
    indicator:
      "掌握微分的应用、微分中值定理的应用、函数的图形与性态、求函数的极值与最值(C1)\n掌握定积分几何应用(C2)\n掌握多元函数微分学的应用(C3)\n熟练掌握二重积分(C4)",
    demand: "",
    commentGist: "",
    getVal: 0.82,
    steps: [
      {
        name: "平时作业",
        rate: "10%",
        score: 40,
        aveScore: 32.93,
      },
      {
        name: "期中考查",
        rate: "20%",
        score: 5,
        aveScore: 4.23,
      },
      {
        name: "期末考试",
        rate: "70%",
        score: 10,
        aveScore: 8.82,
      },
    ],
  },
];
const structs = [
  {
    subQuestionCount: 15,
    score: 2,
  },
  {
    subQuestionCount: 5,
    score: 2,
  },
  {
    subQuestionCount: 6,
    score: 5,
  },
  {
    subQuestionCount: 3,
    score: 10,
  },
];
let distributionList = [];
let targetScore = {
  name: "目标分值",
  totalScore: 0,
  scores: [],
};
structs.forEach((item, index) => {
  for (let i = 0; i < item.subQuestionCount; i++) {
    targetScore.scores.push({
      mainNumber: index + 1,
      subNumber: i + 1,
      score: item.score,
    });
  }
});
distributionList.push(targetScore);
courseTargetList.forEach((item, iindex) => {
  const ts = {
    name: item.name,
    totalScore: 0,
    scores: [],
  };
  structs.forEach((item, index) => {
    for (let i = 0; i < item.subQuestionCount; i++) {
      const score = iindex === i % 3 ? item.score : 0;
      ts.scores.push({
        mainNumber: index + 1,
        subNumber: i + 1,
        score,
      });
    }
  });
  distributionList.push(ts);
});

const dimensionNames = [
  "A1",
  "A2",
  "A3",
  "A4",
  "B1",
  "B2",
  "B2",
  "C1",
  "C2",
  "C3",
  "C4",
];
const workNames = ["作业1", "作业2", "作业3", "作业4", "作业5"];
const students = [
  "周晓",
  "张华",
  "李佳",
  "徐琦",
  "陈真",
  "李阳",
  "张五",
  "赵明",
];
function getRandomNum(num, minnum = 0) {
  return Math.ceil(Math.random() * (num - minnum)) + minnum;
}

function getRandamItems(list, num) {
  const sources = [...list];
  if (!num || num >= list.length) return sources;

  let no = num;
  let data = [];
  while (no) {
    const ind = getRandomNum(sources.length);
    data.push(sources[ind - 1]);
    sources.splice(ind - 1, 1);
    no--;
  }
  return data;
}

const courseStructs = courseTargetList.map((course) => {
  const endRate = getRandomNum(10, 2);
  return {
    name: course.name,
    getVal: course.getVal,
    endExam: "期末考试",
    endDimensions: getRandamItems(dimensionNames, 4),
    endRate: endRate / 10,
    normalExam: "平时考试",
    normalWorks: getRandamItems(workNames, 3),
    normalRate: (10 - endRate) / 10,
  };
});

const studentScores = [...getRandamItems(students, 4), "平均分"].map(
  (item, index) => {
    const courseTargets = courseStructs.map((target) => {
      const ntarget = { ...target };
      ntarget.endDimensions = target.endDimensions.map((ditem) => {
        return {
          name: ditem,
          score: getRandomNum(5),
        };
      });
      ntarget.normalWorks = target.normalWorks.map((witem) => {
        return {
          name: witem,
          score: getRandomNum(100),
        };
      });
      return ntarget;
    });

    const nitem = {
      name: item,
      code: "082001" + index,
      courseTargets,
      totalScore: getRandomNum(100),
    };
    return nitem;
  }
);

export const reportData = {
  baseInfo: {
    courseCode: "261062",
    courseName: "高等数学",
    courseType: "",
    stdScore: undefined,
    examType: "",
    courseStartTime: "2022-2023学年第2学期",
    teachClazz: "2019级生物科学2班",
    teachHours: undefined,
    studentCount: undefined,
    commentCount: 45,
    courseTarget: 0.7,
    teachTeacher: "李老师",
    commentManager: "",
    commentUsers: "",
    examName: "期末考试",
  },
  courseTargetList,
  distributionList,
  scoreDistribution: [
    {
      name: "不及格",
      val: 17.5,
    },
    {
      name: "60-69",
      val: 19.3,
    },
    {
      name: "70-79",
      val: 20.7,
    },
    {
      name: "80-89",
      val: 35.5,
    },
    {
      name: "90-100",
      val: 7,
    },
  ],
  studentScores,
};
// console.log(reportData);
